package es.ucm.fdi.grasia.faerie.examples.bottomUp.app;

import static es.ucm.fdi.grasia.faerie.core.util.ContextURIs.*;

import java.net.URI;

import org.apache.felix.scr.annotations.Component;
import org.apache.log4j.Logger;

import es.ucm.fdi.grasia.faerie.core.AbstractContextObserverComponent;
import es.ucm.fdi.grasia.faerie.core.Attribute;
import es.ucm.fdi.grasia.faerie.core.ContextEvent;
import es.ucm.fdi.grasia.faerie.examples.bottomUp.model.Attribute1;
import es.ucm.fdi.grasia.faerie.examples.bottomUp.model.GenericEntity;

@Component(inherit = true)
public class BottomUpEvalApp extends AbstractContextObserverComponent {

	private GenericEntity entity = null;

	@Override
	protected void addMyReferencedEntities() {
		entity = this.addReferencedEntity(new GenericEntity(localAuthority(), URI.create("/example/"),
				URI.create("ent1")));
	}

	@Override
	protected void doActivate() {
		Attribute1 att = new Attribute1(entity);
		att = this.contextRequest(att);

		this.putObservedElement(att);

		Logger.getLogger(this.getClass()).info("Initial attInstance: " + att);
	}

	@SuppressWarnings("rawtypes")
	@Override
	public void elementUpdated(Attribute att, ContextEvent event) {
		Logger.getLogger(this.getClass()).info("AttInstance updated: " + att.getValue().getData());
	}
}
